﻿'______________________

'Background Worker Demo
'10/6/2011
'______________________

Imports System.Threading
Imports System.ComponentModel


Public Class frmBWorker
    Public Sub New()

        ' This call is required by the designer.
        InitializeComponent()

        '---set BW properties
        BackgroundWorker1.WorkerReportsProgress = True
        BackgroundWorker1.WorkerSupportsCancellation = True
        ProgressBar1.Step = 1

    End Sub

    Private Sub btnStart_Click(sender As System.Object, e As System.EventArgs) Handles btnStart.Click
        If BackgroundWorker1.IsBusy = False Then
            BackgroundWorker1.RunWorkerAsync()  'start background process

        End If
    End Sub

    Private Sub BackgroundWorker1_DoWork(sender As Object, e As System.ComponentModel.DoWorkEventArgs) Handles BackgroundWorker1.DoWork
        '---this is where our BW task goes
        Dim worker As BackgroundWorker = CType(sender, BackgroundWorker)

        For x As Integer = 1 To 100
            If worker.CancellationPending = True Then
                e.Cancel = True
                Exit For
            Else
                Thread.Sleep(200)
                worker.ReportProgress(x)
            End If
        Next

    End Sub

    Private Sub BackgroundWorker1_ProgressChanged(sender As Object, e As System.ComponentModel.ProgressChangedEventArgs) Handles BackgroundWorker1.ProgressChanged
        '---update label on the form which is one the main UI thread
        lblCount.Text = e.ProgressPercentage.ToString() + "%"
        ProgressBar1.Value = e.ProgressPercentage
    End Sub

    Private Sub BackgroundWorker1_RunWorkerCompleted(sender As Object, e As System.ComponentModel.RunWorkerCompletedEventArgs) Handles BackgroundWorker1.RunWorkerCompleted
        MessageBox.Show("Background process completed.", "System Message",
                        MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
    End Sub

    Private Sub btnCancel_Click(sender As Object, e As System.EventArgs) Handles btnCancel.Click
        '---cancel BW
        If BackgroundWorker1.WorkerSupportsCancellation = True Then
            BackgroundWorker1.CancelAsync()             'stop BW thread

        End If
    End Sub
End Class